$ifndef _Graphic_Def_
$define _Graphic_Def_
'***************************************************************************
'***************************************************************************
'***************************************************************************
'***************************************************************************
'***************************************************************************
'*  Name     : Graphic_Def_v0.x.inc                                              
'*  Founding Fathers : Gabi, VaGyver, Ray Ellam, Les Johnson                
'*  Version  : 0.2-6th September 2015                                                          
'*  Version  : 0.3-24th November 2016                                                          
'*  Version  : 0.4-13th September 2017                                      
'*           :     Two parts: 
'*           :     1 - SSD1306_Def and SSD1306_Sub for the SSD1306 Control chip                                                        
'*           :     2 - Graphic_Def and Graphic_Sub for the graphic routine                                                        
'*           :     Proton FontCreator.exe fontdefinitions used              
'*           :     Calling method changed via precompiler and the Macro method removed                                                         
'*           :     Not Used routines will not be compiled                                                         
'*           :     Using the formulas/routines from Les Johnson in ILI9325.Inc (Bresenham)
'*           :          for DrawLine, DrawCircle (and FillCircle)
'*           :                                                              
'*           :                                                              
'***************************************************************************
;
;   DEFINITIONS
;
;***************************************************************************
;   Create System definitions
;---------------------------------------------------------------------------
#disable Print                              ;hijacked Print command
#disable GLCD_Cursor                        ;Cursor positioning
Declare LCD_Type    = Graphic               ;Inform Proton we are using a graphic display
Declare LCD_X_Res   = DisplayWidth
Declare LCD_Y_Res   = DisplayHeight
;---------------------------------------------------------------------------
;   Create variables
;---------------------------------------------------------------------------
;   Proton Print System variable
;---------------------------------------------------------------------------
Dim     GEN         As Byte System                         
Dim     GEN2        As Byte System
Dim     GEN2H       As Byte System
Dim     GEN4        As Byte System
Dim     GEN4_temp   As Byte
Dim     GEN4H       As Byte System
Dim     GEN4H_temp   As Byte
Dim     PP0         As Byte System
Dim     PP0_temp    As Byte
Dim     PP0h        As Byte System
Dim     PP0h_temp   As Byte
Dim     PP0hh       As Byte System
Dim     PP0hh_temp  As Byte
Dim     PP0hhh      As Byte System
Dim     PP0hhh_temp As Byte
Dim     PP2         As Byte System
Dim     PP2_temp    As Byte
Dim     PP2h        As Byte System
Dim     PP2h_temp   As Byte
Dim     PP2hh       As Byte System
Dim     PP2hh_temp  As Byte
Dim     PP2hhh      As Byte System
Dim     PP2hhh_temp As Byte
Dim     PP7         As Byte System
Dim     PP7_temp    As Byte
Dim     PP7h        As Byte System
Dim     PP7h_temp   As Byte
Dim     PP7hh       As Byte System
Dim     PP7hh_temp  As Byte
Dim     PP7hhh      As Byte System
Dim     PP7hhh_temp As Byte
Dim     _GLCD_FLAG  As Byte System              ;Print SET: bit0=Inverse bit1=XOR
Dim     _GLCD_Xpos  As Byte System              ;x-coordinate inside Proton 16bit not used
Dim     _GLCD_XposH As Byte System              ;because Print At can't be bigger as a byte
;---------------------------------------------------------------------------
;   General overall (Cursor, Pixel position and Color)
Dim     Graphic_wCursorX        As Word System  ;Cursor Position X
Dim     Graphic_wCursorY        As Word System  ;Cursor Position Y  
Dim     Graphic_wPixelX         As Word         ;Pixel Position X 
Dim     Graphic_wPixelY         As Word         ;Pixel Position Y  
Dim     Graphic_wColor          As Word         ;Color
;-------------------------------------------------------------------------------
;   DrawPixel
Dim     Graphic_wDrawPixelX      As Word         ;pixel x address
Dim     Graphic_wDrawPixelY      As Word         ;pixel y address
Dim     Graphic_wDrawPixelColor  As Word         ;pixel color
;-------------------------------------------------------------------------------
;   Font en Print
;   The layout of the Font Table is the result of ProtonFontCreator.exe
Symbol  InverseFlag             = _GLCD_FLAG.0
Symbol  XORflag                 = _GLCD_FLAG.1
Dim     Graphic_wFontAddress    As Word         ;Address of the FontAddressTable
Dim     Graphic_bFontHeight     As Byte         ;FontHeight in pixels
Dim     Graphic_bCharWidth      As Byte         ;CharWidth in pixels 
Dim     Graphic_bByteRead       As Byte         ;# bytes for FontHeight
Dim     Graphic_wCharAddress    As Word         ;Address in Char image
Dim     Graphic_bSaveChar       As Byte         ;Character to Print
Dim     Graphic_wSaveTblPtr     As Word         ;Save Table pointer (SFR) TBLPTRL/H
Dim     Graphic_bWidthCount     As Byte
Dim     Graphic_bHeightCount    As Byte
Dim     Graphic_bFontByte       As Byte
;-------------------------------------------------------------------------------
;   Draw and Fill variable
Dim     Graphic_wX0             As Word         ;X start coordinate
Dim     Graphic_wY0             As Word         ;Y start coordinate
Dim     Graphic_wX1             As Word         ;X end coordinate
Dim     Graphic_wY1             As Word         ;Y end coordinate
Dim     Graphic_wDrawLineX0     As Word         ;DrawLine X start coordinate 
Dim     Graphic_wDrawLineY0     As Word         ;DrawLine Y start coordinate
Dim     Graphic_wDrawLineX1     As Word         ;DrawLine X end coordinate
Dim     Graphic_wDrawLineY1     As Word         ;DrawLine Y end coordinate
Dim     Graphic_wX1Save         As Word         ;DrawLine Last X end
Dim     Graphic_wY1Save         As Word         ;DrawLine Last Y end
Dim     Graphic_wDeltaX         As Word         ;DrawLine Delta x coordinates
Dim     Graphic_wDeltaY         As Word         ;DrawLine Delta y coordinates
Dim     Graphic_bStepX          As Byte         ;DrawLine Step in x direction
Dim     Graphic_bStepY          As Byte         ;DrawLine Step in y direction
Dim     Graphic_wDLDecision     As Word         ;DrawLine Decision variable
Dim     Graphic_wDCDecision     As Word         ;Fill/DrawCircle Decision variable
Dim     Graphic_wRadius         As Word         ;Fill/DrawCircle Radius
Dim     Graphic_wXTempP         As Word         ;Fill/DrawCircle X temp coordinate
Dim     Graphic_wYTempQ         As Word         ;Fill/DrawCircle Y temp coordinate
Dim     Graphic_wXYTemp         As Word         ;Fill/DrawCircle XY coordinate diff
Dim     Graphic_wQuadA          As Word         ;Fill/DrawCircle Temp var in Quadrant 1
Dim     Graphic_wQuadB          As Word         ;Fill/DrawCircle Temp var in Quadrant 2
Dim     Graphic_wQuadC          As Word         ;Fill/DrawCircle Temp var in Quadrant 3
Dim     Graphic_wQuadD          As Word         ;Fill/DrawCircle Temp var in Quadrant 4
;-------------------------------------------------------------------------------
;   Temp variable
Dim     Graphic_wTemp           As Word
Dim     Graphic_bTemp           As Byte
;***************************************************************************
;   END Graphic_Def.Inc
;***************************************************************************
$endif
;===========================================================================

